/// <reference types="react" />
export declare type StoresByKey = {
    [index: string]: StateStore<{}>;
};
export declare type StateUpdatedCallback = () => void;
export default class StateStore<T> {
    private _state;
    private listeners;
    constructor(initialState: T);
    state: Partial<T>;
    private fireListeners;
    setState(newState: Partial<T>): void;
    subscribe(key: string, callback: StateUpdatedCallback): void;
    unsubscribe(callback: StateUpdatedCallback): void;
}
export declare const root: (RootComponent: import("react").ComponentType<{}>, stores: StoresByKey) => (props: any) => import("react").FunctionComponentElement<import("react").ProviderProps<{}>>;
export declare function container(ContainerComponent: React.ComponentType, mapState: (stores: {
    [index: string]: StateStore<{}>;
}, props: any) => any): {
    new (props: Readonly<{}>): {
        stores: {
            [index: string]: StateStore<{}>;
        };
        updateState: () => void;
        componentWillUnmount(): void;
        getStateProxy(store: StateStore<{}>): any;
        getStoreProxy(store: StateStore<any>): any;
        render(): import("react").FunctionComponentElement<import("react").ConsumerProps<{}>>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{}>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{}> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: {}, context?: any): {
        stores: {
            [index: string]: StateStore<{}>;
        };
        updateState: () => void;
        componentWillUnmount(): void;
        getStateProxy(store: StateStore<{}>): any;
        getStoreProxy(store: StateStore<any>): any;
        render(): import("react").FunctionComponentElement<import("react").ConsumerProps<{}>>;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<{}>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{}> & Readonly<{
            children?: import("react").ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: import("react").ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: import("react").ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<{}>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{}>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{}>, nextState: Readonly<{}>, nextContext: any): void;
    };
    contextType?: import("react").Context<any> | undefined;
};
